#include <iostream>
#include <array>
#include <sstream>

struct Sudoku {
	std::array<std::array<int, 9>, 9> field = {};
};

std::ostream& operator<<(std::ostream& out, const Sudoku& s) {
	for(int y=0; y<9; y++) {
		if(y%3==0 && y>0) {
			std::cout << "----------------------\n";
		}
		for(int x=0; x<9; x++) {
			if(x%3==0 && x>0) {
				std::cout << " |";
			}
			std::cout << " " << s.field[x][y];
		}
		std::cout << "\n";
	}
	return out;
}

std::istream& operator>>(std::istream& in, Sudoku& s) {
	auto ignore = std::string();

	for(int y=0; y<9; y++) {
		if(y%3==0 && y>0) {
			in >> ignore;
		}
		for(int x=0; x<9; x++) {
			if(x%3==0 && x>0) {
				in >> ignore;
			}
			in >> s.field[x][y];
		}
	}
	return in;
}


// TODO: bool valid_move(const Sudoku& sudoku, int x, int y, int number)
// TODO: bool solve(Sudoku sudoku)

int main() {
	auto sudoku = Sudoku{};

	std::cin  >> sudoku;
	std::cout << sudoku << "\n";

	if(!solve(sudoku)) {
		std::cout << "Keine Loesung gefunden\n";
	}
}

